'-------------------------------------------------------------------------------
'   Siemens S65   Lph88   Atmega162
'-------------------------------------------------------------------------------
'     12  ( be carefull ).
'
'                    LCD            AVR
'                    ---            ---
'                    1 /RS          B4
'                    2 /Reset       B3
'                    3 /CS          B2
'                    4 /CLK         B7
'                    5 /DAT         B5
'                    6 /Vcc        3 V (max.3.3 V, min.2.4 V)
'                    7 /GND        GND
'                    8 /Vdigital   3 Volt
'                    9 /LED+       12.0 V
'                    10/LED-       GND
'-------------------------------------------------------------------------------
'
'          Siemens S65
'     ,      
'-------------------------------------------------------------------------------
'                  Bascom-AVR 1.11.8./...
'-------------------------------------------------------------------------------
$regfile = "m162def.dat"                                    ' 162 
$crystal = 16000000                                         ' 16 
$baud = 115200                                              '   115200
$hwstack = 128
$swstack = 128
$framesize = 128


Wait 2
Ddrb = &B11111111                                           'b  



Rs Alias Portb.4                                            '  Portb.4     RS
Rst Alias Portb.3                                           '    
Cs Alias Portb.2
Clk Alias Portb.7
Dat Alias Portb.5

'   /

Config Portc = Output




'   (    )
Const White = &HFFFF                                        ' 
Const Black = &H0000                                        '

Const Red = &HF800                                          '
Const Green = &H7C0                                         '
Const Blue = &H1F                                           '
Const Whiblu = &H7FF                                        '


'     
Dim Temp As Byte


Dim A As Word , N As Byte , Temp1 As Word


'   
Declare Sub Clear_screen(byval Clear_color As Word)
Declare Sub Wordout()
Declare Sub Byteout()
Declare Sub S65_init()
Declare Sub Window_locate(byval X_start As Byte , Byval Y_start As Byte , Byval X_end As Byte , Byval Y_end As Byte)
Declare Sub Cspulse()
Declare Sub Command_send(byval Nn As Byte)
Declare Sub Data_send(byval Aa As Word)





' SPI    
Config Spi = Hard , Interrupt = On , Data Order = Msb , Master = Yes , Polarity = High , Phase = 1 , Clockrate = 4 , Noss = 1
Spiinit
' SPI
Call S65_init



Call Clear_screen(black)
Set Cs
' Window locate
'  -   
'  -   
'  -   
'  -   
'  :
' (   -   )
'  
' (   -   )
Call Window_locate(30 , 30 , 120 , 160)
A = Blue
For Temp1 = 1 To 11920
If Temp1 > 5950 Then A = Red
Call Wordout()
Next Temp1
Set Cs
Do
Loop

End



'------------------------------------------
'###############################################################################
Sub Cspulse                                                 '  CS
  Set Cs
  nop
  Reset Cs
End Sub

'------------   ---------------------------
Sub Command_send(byval Nn As Byte)                          ' 
N = &H74
Call Byteout()
N = 0
Call Byteout()
N = Nn
Call Byteout()
Call Cspulse
End Sub
'----------   ------------------------------
Sub Data_send(byval Aa As Word)                             ' 
N = &H76
Call Byteout()
A = Aa
Call Wordout()
Call Cspulse
End Sub
'--------       ----------------
Sub Wordout
      lds r23, {a+1}
      !out spdr, r23
      lds r23, {a}
Wait_trh:
      sbis spsr, spif
      rjmp wait_trh
      !out spdr, r23
Wait_trl:
      sbis spsr, spif
      rjmp wait_trl
End Sub

'-------------    --------------------------
Sub Byteout
      lds r23, {n}
      !out spdr, r23
 Waitresult:
      sbis spsr, spif
      rjmp waitresult
End Sub

'-------------------------------------------------------------------------------
Sub S65_init
Reset Rst
Set Cs
Set Rs
Waitms 1
Set Rst
Waitms 10
Reset Cs
Restore Ini_code
For Temp = 0 To 33
Read N
Call Command_send(n)
Read A
Call Data_send(a)
Next Temp
Waitms 300
Set Cs
End Sub
'-------------------------------------------------------------------------------


Sub Clear_screen(clear_color As Word)
Dim Temp2 As Word

Reset Cs

Call Command_send(&H16)
Call Data_send(&H8400)                                      '    (131)   
Call Command_send(&H17)
Call Data_send(&Haf00)
Call Command_send(&H21)                                     '   ,    
Call Data_send(&H0)
Call Command_send(&H22)
N = &H76
Call Byteout()
A = Clear_color

For Temp2 = 1 To 46464
Call Wordout()
Next Temp2

End Sub

Sub Window_locate(x As Byte , Y As Byte , X_pixel As Byte , Y_pixel As Byte)
Reset Cs

Call Command_send(&H16)

N = &H76
Call Byteout()
N = X_end
Call Byteout()
N = X_start
Call Byteout()
Call Cspulse

Call Command_send(&H17)
N = &H76
Call Byteout()
N = Y_end
Call Byteout()
N = Y_start
Call Byteout()
Call Cspulse


Call Command_send(&H21)
N = &H76
Call Byteout()
N = X_start
Call Byteout()
N = Y_start
Call Byteout()
Call Cspulse

Call Command_send(&H22)
N = &H76
Call Byteout()
End Sub
Ini_code:
Data &H07 , &H0000% , &H02 , &H0400% , &H04 , &H0000% , &H0C , &H0001% , &H0D , &H0616% , &H0E , &H1010%
Data &H03 , &H000C% , &H0E , &H2D1F% , &H0D , &H0616% , &H01 , &H0215% , &H0F , &H0000% , &H0B , &H0000%
Data &H11 , &H0000% , &H06 , &H0000% , &H05 , &H0030% , &H14 , &HAF00% , &H15 , &H0000% , &H16 , &H8300%
Data &H17 , &HAF00% , &H20 , &H0000% , &H30 , &H0000% , &H31 , &H0400%
Data &H32 , &H0207% , &H33 , &H0700% , &H34 , &H0005% , &H35 , &H0703% , &H36 , &H0707% , &H37 , &H0007%
Data &H3A , &H1200% , &H3B , &H0009% , &H07 , &H0005% , &H07 , &H0025% , &H07 , &H0027% , &H07 , &H0037%


Simbol:
Data &H00 , &H00 , &H00 , &H38 , &H18 , &H18 , &H18 , &H18 , &H18 , &H18 , &H18 , &H3C , &H00 , &H00